      parameter(NPROF=72,NLAT=180,NLON=360)
      real*8 prof(NPROF),vref(NPROF),vs(NPROF)
      real*8 profs(NPROF),profi(NPROF),ro(NPROF)
      real*8 profa(NPROF),crefa(NPROF)
      real*8 c(NLAT,NLON),er(NLAT,NLON)
      real*8 cp(NLAT,NLON),ampG(NLAT,NLON),phiao(NLAT,NLON)
      real*8 da1(NLAT,NLON),da2(NLAT,NLON),alpha(NLAT,NLON)
      real*8 alphmax,moy,moyampG,ampGmax 
      real*8 lat,lon,latmax,lonmax
      integer sauti, sautj
      character*32 filein,fileanis,fileout
      character*32 fileaout,fileaout2
      character    cid*3
c juillet 2012
c 2 fichiers de sortie anisotrope
c anvs.prof.xy -> lat, lon, angle
c paniso.prof.xy  -> lat,lon,paniso
c
c---------------------------------------------------------
c 27/01/05 code by Eric Debayle
c reads output vsfin and anvsfin files from
c regiostack6_ompV3d.f and convert
c velocities and anisotropy into xy files for plot using GMT
c density is taken from PREM
c---------------------------------------------------------
c SV-wave azimuthal anisotropy
c    The anvsfin file contains the A1 and A2 parameters 
c     as defined in equation 5 of  
c     Leveque, Debayle and Maupin, GJI, 133, 529-540, (1998)
c     (named da1 and da2 in this code)
c    The peak to peak amplitude of the SV wave azimutal anisotropy is
c      amp(G)=(2*sqrt((da2**2)+(da1**2))/c)
c    and for the G parameter 
c      amp(G)=2*ro*betaV*[(2*sqrt((da2**2)+(da1**2))/c)]
c    Two anisotropic files are produced each of them contains HALF the
c      length of the anisotropy. This allows to center the anisotropic bar 
c      with GMT.
c    We use a scale factor 'corr' to plot on the 
c    GMT maps an amplitude of corr % with a 1 cm line.
c---------------------------------------------------------
      iout=10
      iaout=12
      iaout2=13
      rad=0.017453293
      radi=0.5/rad

c     ili nb line; icol nb col; xpas bloc size;
c     x0= upper left longitude;  y0= upper right colatitude
c     inprof number of depths
      y0=0.
      x0=-180.
c     xpas=1
c     ili=180
c     icol=360 
      xpas=2
      ili=90
      icol=180 
      filein='vsfin.0040-1000'
      fileanis='anvsfin.0040-1000'
      inprof=33
      open(7,file=filein)
      open(9,file=fileanis)
      print *,'Enter a value for the scale factor corr'
      print *,'(1 cm will be corr % of anisotropy on the GMT maps' 
      print *,' using MEASURE_UNIT=inch in your .gmtdefaults file)'
      read(*,*)corr     

      open(12,status='old',file='./des.sprem.100s.rovs.regio62gmt')
      read(12,*)
      read(12,*)
      read(12,*) npr
      do 15 i=1,npr
       read(12,*) profi(i),ro(i),vs(i)
       ro(i)=ro(i)*1000
       vs(i)=vs(i)*1000
15    continue
      close(12)

c      i=1
c      open(12,status='old',file='RefAniso')
c16    read(12,*,end=998) profa(i),crefa(i)
c      i=i+1
c      go to 16   
c998   continue
c      npa=i-1
c      close(12)
c
c-------------------------------------------------------------

      do 20 iprof=1,inprof
       read(7,*)tt
       read(9,*)tt
       itt=int(tt)
       write(cid,'(i3.3)')itt
       fileout= 'vs.'//cid(:lnblnk(cid))//'.xy'
       fileaout= 'anvs.'//cid//'.xy'
       fileaout2= 'paniso.'//cid//'.xy'
       open(iout,file=fileout)
       open(iaout,file=fileaout)
       open(iaout2,file=fileaout2)
       profs(iprof)=0.-tt
       print *,'--------------------------------------'
       print *,'prof',iprof,':',tt
       do 30 i=1,ili
   30  read(7,'(20(f12.4,1x))')(c(i,j),j=1,icol)
c  30  read(7,'(20(f10.6,1x))')(c(i,j),j=1,icol)
       do 50 i=1,ili
   50  read(9,'(20(f12.4,1x))')(da1(i,j),j=1,icol)
c  50  read(9,'(20(f10.6,1x))')(da1(i,j),j=1,icol)
       do 60 i=1,ili
   60  read(9,'(20(f12.4,1x))')(da2(i,j),j=1,icol)
c  60  read(9,'(20(f10.6,1x))')(da2(i,j),j=1,icol)

       do 85 k=1,npr 
       if ((profi(k)-tt).lt.0.001)then
       densite=ro(k)
       beta=vs(k)
       endif
 85    continue
    
c     calcul du pourcentage de perturbation par rapport a la valeur
c     moyenne de reference choisie.

       cref=0.
        do 100 i=1,ili
        do 100 j=1,icol
 100    cref=cref+c(i,j)
        cref=cref/ili/icol 
        write(*,'(a,f8.3)')'Average Vs in km/s: ',cref
c Reference values for PREM
c          if (tt.eq.40.)cref=4.400
c          if (tt.eq.50.)cref=4.402
c          if (tt.eq.75.)cref=4.409
c          if (tt.eq.100.)cref=4.413
c          if (tt.eq.125.)cref=4.420
c          if (tt.eq.150.)cref=4.425
c          if (tt.eq.175.)cref=4.432
c          if (tt.eq.200.)cref=4.436
c          if (tt.eq.225.)cref=4.619
c          if (tt.eq.250.)cref=4.663
c          if (tt.eq.275.)cref=4.683
c          if (tt.eq.300.)cref=4.700
c          if (tt.eq.325.)cref=4.718
c          if (tt.eq.350.)cref=4.730
c          if (tt.eq.375.)cref=4.750
c          if (tt.eq.400.)cref=4.849
c          if (tt.eq.450.)cref=5.078
c          if (tt.eq.500.)cref=5.224
c          if (tt.eq.550.)cref=5.370
c          if (tt.eq.600.)cref=5.516
c          if (tt.eq.650.)cref=5.552
c          if (tt.eq.700.)cref=6.019
c Reference values for PREM 100 s
c       cref=beta/1000.

c       do ipa=1,npa
c        if(profa(ipa).eq.tt) cref=crefa(ipa)
c       enddo

        write(*,'(a,2f8.3)')'Reference value used for Vs in km/s: '
     *,tt,cref

       cmax=0
       cmin=0
       rms=0.
       do 110 i=1,ili
       do 110 j=1,icol
        cp(i,j)=(c(i,j)-cref)/cref*100
        rms=rms+cp(i,j)*cp(i,j)
        if(cp(i,j).gt.cmax)cmax=cp(i,j)
        if(cp(i,j).lt.cmin)cmin=cp(i,j)
 110   continue
        write(*,*)'Max and min Vs perturbation in %'
        write(*,'(2(f8.3,1x))')cmax,cmin
        rms=rms/(ili*icol)
        rms=sqrt(rms)
        write(*,*)'RMS Vs perturbation in %',tt,rms        

       moy=0.
       moyampG=0.
       alphmax=0.
       ampGmax=0.
       sauti=0
       fs=2
       fs=(fs/xpas)*fs
c      fs=1
       do 130 i=1,ili
        sautj=0
        sauti=sauti+1
        if (sauti.eq.2*fs)sauti=0
        lat=y0+(i-1)*xpas+xpas/2.
        lat=90.-lat 
c      do 130 j=1,icol+5
       do 130 j=1,icol
         sautj=sautj+1
         if (sautj.eq.2*fs.and.abs(lat).ge.0.and.abs(lat).lt.50)sautj=0
         if (sautj.eq.3*fs.and.abs(lat).ge.50.and.abs(lat).lt.70)sautj=0
         if (sautj.eq.4*fs.and.abs(lat).ge.70.and.abs(lat).lt.80)sautj=0
         if (sautj.eq.6*fs.and.abs(lat).ge.80.and.abs(lat).le.90)sautj=0
         lon=x0+(j-1)*xpas+xpas/2.
         if (j.gt.icol)then
            jj=j-icol
         else
            jj=j
         endif
         write(iout,'(f8.3,1x,f8.3,2x,f8.3)')lat,lon,cp(i,jj)
          alpha(i,jj)=sqrt((da1(i,jj)**2)+(da2(i,jj)**2))
c    da1 et da2 are in km/s and converted in m/s (*1000)
          ampG(i,jj)=2*densite*beta*1000*alpha(i,jj)
          alpha(i,jj)= 100*(alpha(i,jj)/c(i,jj))
c   Extracting max and mean of peak to peak anisotropy
          moy=moy+2*alpha(i,jj)
          moyampG=moyampG+2*ampG(i,jj)
           if(alpha(i,jj).gt.alphmax)then
             alphmax=alpha(i,jj)
             ampGmax=ampG(i,jj)
             latmax=lat
             lonmax=lon
           endif
c   Scale factor to have on the GMT maps corr % aniso = 1 cm.
          alpha(i,jj)=alpha(i,jj)/(2.54*corr)
          phiao(i,jj)= radi*atan2(da2(i,jj),da1(i,jj))
           if(sauti.eq.0.and.sautj.eq.0)then
            write(iaout,'(4(f8.3,1x))')lat,lon,phiao(i,jj),2*alpha(i,jj)
           endif
           alpha(i,jj)=alpha(i,jj)*(2.54*corr) 
           write(iaout2,'(4(f8.3,1x))')lat,lon,2*alpha(i,jj)
 130    continue
      moy=moy/(ili*icol)
      moyampG=moyampG/(ili*icol)
      write(*,*)'Average peak to peak anisotropy in %:'
      write(*,'(2(f8.3,1x),a)')tt,moy,' grep '
      write(*,*)'Average peak to peak amplitude of G in GigaPascals:'
      write(*,'(f11.6)')moyampG/10**9
      write(*,*)'Maximum peak to peak anisotropy in % '
      write(*,*)'+ location (lat,lon):'
      write(*,'(3(f8.3,1x))')2*alphmax,latmax,lonmax
      write(*,*)'Maximum peak to peak G amplitude in GigaPascals:'
      write(*,*)'for the same point :'
      write(*,'(f11.6)')2*ampGmax/10**9
      close(iout)
      close(iaout)
      close(iaout2)

20    continue

      close(7)
      close(9)
      stop
      end
